## tgt 1.0.85

=== Makefile ===
VERSION ?= 1.0.85

CHECK_CC = cgcc
CHECK_CC_FLAGS = '$(CHECK_CC) -Wbitwise -Wno-return-void -no-compile $(ARCH)'

# Define a common prefix where binaries and docs install
PREFIX ?= /usr

# Export VERSION and PREFIX so sub-make knows about them
export VERSION PREFIX

# Export the feature switches so sub-make knows about them
export ISCSI_RDMA
export CEPH_RBD
export GLFS_BD
export SD_NOTIFY

.PHONY: all
all: programs doc conf scripts

# Targets for the /usr/sbin utilities
.PHONY: programs install-programs clean-programs
programs:
	$(MAKE) -C usr

install-programs:
	$(MAKE) -C usr install

clean-programs:
	$(MAKE) -C usr clean

# Targets for man pages and other documentation
.PHONY: doc install-doc clean-doc
doc:
	$(MAKE) -C doc

install-doc:
	$(MAKE) -C doc install

clean-doc:
	$(MAKE) -C doc clean

# Targets for scripts
.PHONY: scripts install-scripts clean-scripts
scripts:
	$(MAKE) -C scripts

install-scripts:
	$(MAKE) -C scripts install

clean-scripts:
	$(MAKE) -C scripts clean


# Targets for configuration stubs
.PHONY: conf install-conf clean-conf
conf:
	$(MAKE) -C conf

install-conf:
	$(MAKE) -C conf install

clean-conf:
	$(MAKE) -C conf clean

.PHONY: install
install: install-programs install-doc install-conf install-scripts

.PHONY: rpm
rpm:
	@./scripts/build-pkg.sh rpm

.PHONY: deb
deb:
	@./scripts/build-pkg.sh deb

.PHONY: clean
clean-pkg:
	rm -fr pkg

.PHONY: clean
clean: clean-programs clean-doc clean-conf clean-scripts clean-pkg

.PHONY:check
check: ARCH=$(shell sh scripts/checkarch.sh)
check:
	CC=$(CHECK_CC_FLAGS) $(MAKE) all

.PHONY:check32
check32: override ARCH=-m32
check32:
	CC=$(CHECK_CC_FLAGS) $(MAKE) all

.PHONY:check64
check64: override ARCH=-m64
check64:
	CC=$(CHECK_CC_FLAGS) $(MAKE) all

cscope:
	find -name '*.[ch]' > cscope.files
	cscope -bq

=== debian/changelog ===
tgt (1:1.0.85-1ubuntu1) lunar; urgency=medium

  * Add fio-examples as a localtgt test dependency

 -- Danilo Egea Gondolfo <danilo.egea.gondolfo@canonical.com>  Thu, 23 Mar 2023 16:46:49 -0300

tgt (1:1.0.85-1) unstable; urgency=medium

  * New upstream version 1.0.85
    a73ebbd Remove blank from Documentation line in service file
    a3720d2 Remove duplicate include of sysmacros.h

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 09 Jan 2023 16:58:58 +0200

tgt (1:1.0.84-1) unstable; urgency=medium

  * New upstream version 1.0.84:
    646aa73 fix use-after-free in iser_conn_free() (Closes: #1013052)
    9fd4a25 fix bug: target bound initiator-name but client cannot discovery
            the target device
    4c81b97 Remove clear non-existent directories: ibmvio, fc on "make clean"
            command
    7a2da00 Fix FMK and other flags
  * d/watch: relax tarball matching expression
  * Bump Standards-Version to 4.6.1; no changes needed
  * d/control: point Homepage to Github
  * Fix example location in manages (Closes: #979509)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 26 Sep 2022 15:14:57 +0300

=== debian/control ===
Source: tgt
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper-compat (= 13), libibverbs-dev, librdmacm-dev (>= 1.0.16),
	       xsltproc, docbook-xsl, librbd-dev, libglusterfs-dev, uuid-dev,
               bash-completion, libsystemd-dev, libaio-dev, pkg-config
Vcs-Git: https://salsa.debian.org/debian/tgt.git
Vcs-Browser: https://salsa.debian.org/debian/tgt
Standards-Version: 4.6.1
Homepage: https://github.com/fujita/tgt

Package: tgt
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, lsb-base, libconfig-general-perl, sg3-utils
Pre-Depends: ${misc:Pre-Depends}
Suggests: tgt-glusterfs, tgt-rbd
Description: Linux SCSI target user-space daemon and tools
 The Linux target framework (tgt) allows a Linux system to provide SCSI
 devices (targets) over networked SCSI transports.
 .
 tgt consists of a user-space daemon and user-space tools currently
 supporting the following transports:
 .
  - iSCSI (SCSI over IP)
  - iSER (iSCSI over RDMA, using Infiniband)
 .
 tgt also supports different storage types for use as backing stores for SCSI
 Logical Units:
 .
  - Plain files and block devices
  - Ceph/RADOS RBD volumes
  - GlusterFS volumes
 .
 This package includes the daemon and user-space tools.

Package: tgt-rbd
Architecture: linux-any
Depends: tgt (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Linux SCSI target user-space daemon and tools - RBD support
 The Linux target framework (tgt) allows a Linux system to provide SCSI
 devices (targets) over networked SCSI transports.
 .
 tgt consists of a user-space daemon and user-space tools currently
 supporting the following transports:
 .
  - iSCSI (SCSI over IP)
  - iSER (iSCSI over RDMA, using Infiniband)
 .
 tgt also supports different storage types for use as backing stores for SCSI
 Logical Units:
 .
  - Plain files and block devices
  - Ceph/RADOS RBD volumes
  - GlusterFS volumes
 .
 This package enables tgt to use Ceph/RADOS block devices (RBD) as backing
 store for SCSI Logical Units.

Package: tgt-glusterfs
Architecture: linux-any
Depends: tgt (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Linux SCSI target user-space daemon and tools - GlusterFS support
 The Linux target framework (tgt) allows a Linux system to provide SCSI
 devices (targets) over networked SCSI transports.
 .
 tgt consists of a user-space daemon and user-space tools currently
 supporting the following transports:
 .
  - iSCSI (SCSI over IP)
  - iSER (iSCSI over RDMA, using Infiniband)
 .
 tgt also supports different storage types for use as backing stores for SCSI
 Logical Units:
 .
  - Plain files and block devices
  - Ceph/RADOS RBD volumes
  - GlusterFS volumes
 .
 This package enables tgt to use GlusterFS volumes as backing store for SCSI
 Logical Units.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

FEATURES = ISCSI_RDMA=1 CEPH_RBD=1 GLFS_BD=1 SD_NOTIFY=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with bash-completion

override_dh_auto_build:
	dh_auto_build -- $(FEATURES)

override_dh_auto_install:
	$(MAKE) $(FEATURES) DESTDIR=$(CURDIR)/debian/tgt install

override_dh_installinit:
	dh_installinit --no-stop-on-upgrade

override_dh_installsystemd:
	dh_installsystemd --no-stop-on-upgrade

override_dh_install:
	dh_install
	rm -rf $(CURDIR)/debian/tgt/usr/lib

override_dh_strip:
	dh_strip --dbgsym-migration='tgt-dbg (<< 1:1.0.73-1~)'

.PHONY: override_dh_auto_build override_dh_auto_install \
	override_dh_installinit override_dh_install \
	override_dh_strip override_dh_installsystemd

=== debian/tests/control ===
Tests: daemon admin
Depends: tgt

Tests: storage
Depends: tgt, tgt-rbd, tgt-glusterfs
Restrictions: needs-root isolation-container allow-stderr

Tests: localtgt
Depends: tgt, open-iscsi, fio, fio-examples
Restrictions: needs-root isolation-machine allow-stderr

## tgt 20070924

=== usr/Makefile ===
ifneq ($(XEN),)
XEN_ROOT = ../..
include $(XEN_ROOT)/tools/Rules.mk
LINUX_ROOT := $(wildcard $(XEN_ROOT)/linux-2.6.*-xen)
INCLUDES += -I$(XEN_LIBXC) -I$(XEN_XENSTORE) -I$(XEN_ROOT)/xen/include
INCLUDES += -I$(LINUX_ROOT)/include -I.
LIBAIO_DIR = ../libaio/src
AIOLIBS := $(LIBAIO_DIR)/libaio.a
CFLAGS += -I$(XEN_LIBXC) -I$(LIBAIO_DIR)
CFLAGS += $(INCLUDES) -I. -I../../xenstore
CFLAGS += -DXEN -DUSE_KERNEL
LIBS := -L. -L.. -L../lib
LIBS += -L$(XEN_LIBXC)
LIBS += -lxenctrl
LIBS += -L$(XEN_XENSTORE) -lxenstore $(AIOLIBS)
TGTD_OBJS += $(addprefix xen/, xen.o xs_api.o xenbus.o)
TGTD_OBJS += tgtif.o bs_xen.o
else
INCLUDES += -I../include -I$(KERNELSRC)/include
endif

ifneq ($(SGV4),)
TGTD_OBJS += spt_sgv4.o
else
TGTD_OBJS += spt_sgv3.o
endif

ifneq ($(IBMVIO),)
CFLAGS += -DIBMVIO -DUSE_KERNEL
TGTD_OBJS += $(addprefix ibmvio/, ibmvio.o)
TGTD_OBJS += bs_mmap.o tgtif.o
endif

ifneq ($(ISCSI),)
CFLAGS += -DISCSI
TGTD_OBJS += $(addprefix iscsi/, conn.o param.o session.o \
		iscsid.o target.o chap.o transport.o iscsi_tcp.o \
		isns.o libcrc32c.o)
TGTD_OBJS += bs_sync.o
LIBS += -lcrypto -lpthread
endif

ifneq ($(FCP),)
CFLAGS += -DFCP -DUSE_KERNEL
TGTD_OBJS += $(addprefix fc/, fc.o)
TGTD_OBJS += bs_mmap.o tgtif.o
endif

INCLUDES += -I.

CFLAGS += -D_LARGEFILE64_SOURCE
CFLAGS += $(INCLUDES)
CFLAGS += -g -O2 -Wall -Wstrict-prototypes -fPIC

PROGRAMS += tgtd tgtadm
TGTD_OBJS += tgtd.o mgmt.o target.o scsi.o log.o driver.o util.o work.o \
		parser.o spc.o sbc.o mmc.o osd.o spt.o scc.o smc.o

TGTD_DEP = $(TGTD_OBJS:.o=.d)

.PHONY:all
all: $(PROGRAMS)

tgtd: $(TGTD_OBJS)
	$(CC) $^ -o $@ $(LIBS)

-include $(TGTD_DEP)

tgtadm: tgtadm.o
	$(CC) $^ -o $@

-include tgtadm.d

%.o: %.c
	$(CC) -c $(CFLAGS) $*.c -o $*.o
	@$(CC) -MM $(CFLAGS) -MF $*.d -MT $*.o $*.c

.PHONY: install
install: $(PROGRAMS)
	install -m 0755 $(PROGRAMS) $(DESTDIR)/usr/sbin

.PHONY: clean
clean:
	rm -f *.[od] $(PROGRAMS) iscsi/*.[od] ibmvio/*.[od] fc/*.[od] \
		xen/*.[od]

=== usr/ibmvio/Makefile ===
CFLAGS += -O2 -fno-inline -Wall -fPIC -Wstrict-prototypes -I$(KERNELSRC)/include -I../../usr

clean:
	rm -f *.o
